From 8147f3f7c89c14c459f67eda3490e3b6d3f02a84 Mon Sep 17 00:00:00 2001
From: Ida Dittrich <i.dittrich@valueon.ch>
Date: Fri, 9 Jan 2026 12:14:47 +0100
Subject: [PATCH 5/5] fix: generalized event manager for message streaming

---
 docs/STREAMING_UTILITY_ARCHITECTURE.md       | 314 +++++++++++++++++++
 modules/features/chatbot/eventManager.py     | 181 +++++++----
 modules/features/chatbot/mainChatbot.py      |  53 ++--
 modules/interfaces/interfaceDbChatObjects.py |  31 +-
 modules/routes/routeChatbot.py               | 123 ++------
 5 files changed, 523 insertions(+), 179 deletions(-)
 create mode 100644 docs/STREAMING_UTILITY_ARCHITECTURE.md

diff --git a/modules/features/chatbot/eventManager.py b/modules/features/chatbot/eventManager.py
index 48d1601b..8bc4ff94 100644
--- a/modules/features/chatbot/eventManager.py
+++ b/modules/features/chatbot/eventManager.py
@@ -1,21 +1,23 @@
 # Copyright (c) 2025 Patrick Motsch
 # All rights reserved.
 """
-Event manager for chatbot streaming.
-Manages event queues for SSE streaming of chatbot progress updates.
+Generic streaming event manager for real-time updates.
+Manages event queues for SSE streaming across all features (chatbot, workflows, documents, etc.).
+Supports event-driven streaming instead of polling.
 """
 
 import logging
 import asyncio
-from typing import Dict, Optional, Any
+from typing import Dict, Optional, Any, List, AsyncIterator, Set
 from datetime import datetime
 
 logger = logging.getLogger(__name__)
 
 
-class ChatbotEventManager:
+class StreamingEventManager:
     """
-    Manages event queues for chatbot streaming.
+    Generic event manager for real-time streaming across all features.
+    Supports multiple event types and contexts (workflows, documents, tasks, etc.).
     Thread-safe event emission and queue management.
     """
     
@@ -24,128 +26,199 @@ class ChatbotEventManager:
         self._queues: Dict[str, asyncio.Queue] = {}
         self._locks: Dict[str, asyncio.Lock] = {}
         self._cleanup_tasks: Dict[str, asyncio.Task] = {}
+        self._subscribers: Dict[str, Set[str]] = {}  # context_id -> set of queue_ids (for future multi-subscriber support)
     
-    def create_queue(self, workflow_id: str) -> asyncio.Queue:
+    def create_queue(self, context_id: str) -> asyncio.Queue:
         """
-        Create a new event queue for a workflow.
+        Create a new event queue for a context.
         
         Args:
-            workflow_id: Workflow ID
+            context_id: Context ID (workflow_id, document_id, task_id, etc.)
             
         Returns:
-            Event queue for the workflow
+            Event queue for the context
         """
-        if workflow_id not in self._queues:
-            self._queues[workflow_id] = asyncio.Queue()
-            self._locks[workflow_id] = asyncio.Lock()
-            logger.debug(f"Created event queue for workflow {workflow_id}")
-        return self._queues[workflow_id]
+        if context_id not in self._queues:
+            self._queues[context_id] = asyncio.Queue()
+            self._locks[context_id] = asyncio.Lock()
+            self._subscribers[context_id] = set()
+            logger.debug(f"Created event queue for context {context_id}")
+        return self._queues[context_id]
     
-    def get_queue(self, workflow_id: str) -> Optional[asyncio.Queue]:
+    def get_queue(self, context_id: str) -> Optional[asyncio.Queue]:
         """
-        Get existing event queue for a workflow.
+        Get existing event queue for a context.
         
         Args:
-            workflow_id: Workflow ID
+            context_id: Context ID
             
         Returns:
             Event queue if exists, None otherwise
         """
-        return self._queues.get(workflow_id)
+        return self._queues.get(context_id)
     
     async def emit_event(
         self,
-        workflow_id: str,
+        context_id: str,
         event_type: str,
-        message: str,
-        step: Optional[str] = None,
-        data: Optional[Dict[str, Any]] = None
+        data: Dict[str, Any],
+        event_category: str = "default",
+        message: Optional[str] = None,
+        step: Optional[str] = None
     ):
         """
-        Emit an event to the workflow's event queue.
+        Emit an event to the context's event queue.
         
         Args:
-            workflow_id: Workflow ID
-            event_type: Type of event ("status", "progress", "complete", "error")
-            message: Event message
-            step: Current processing step (optional)
-            data: Additional event data (optional)
+            context_id: Context ID (workflow_id, document_id, etc.)
+            event_type: Type of event ("message", "log", "status", "progress", "complete", "error", "chatdata")
+            data: Event data dictionary (will be included in event)
+            event_category: Category of event for filtering ("chat", "workflow", "document", etc.)
+            message: Optional event message (for backward compatibility)
+            step: Optional processing step (for backward compatibility)
         """
-        queue = self.get_queue(workflow_id)
+        queue = self.get_queue(context_id)
         if not queue:
-            logger.debug(f"No event queue found for workflow {workflow_id}, skipping event")
+            logger.debug(f"No event queue found for context {context_id}, skipping event")
             return
         
         event = {
             "type": event_type,
-            "message": message,
+            "category": event_category,
             "timestamp": datetime.now().timestamp(),
-            "step": step,
-            "data": data or {}
+            "data": data,
+            "message": message,  # For backward compatibility
+            "step": step  # For backward compatibility
         }
         
         try:
             await queue.put(event)
-            logger.debug(f"Emitted {event_type} event for workflow {workflow_id}: {message[:50]}")
+            logger.debug(f"Emitted {event_type} event (category: {event_category}) for context {context_id}")
         except Exception as e:
-            logger.error(f"Error emitting event for workflow {workflow_id}: {e}")
+            logger.error(f"Error emitting event for context {context_id}: {e}")
     
-    async def cleanup(self, workflow_id: str, delay: float = 60.0):
+    async def stream_events(
+        self,
+        context_id: str,
+        event_categories: Optional[List[str]] = None,
+        timeout: Optional[float] = None
+    ) -> AsyncIterator[Dict[str, Any]]:
+        """
+        Async generator for streaming events from a context.
+        
+        Args:
+            context_id: Context ID to stream events from
+            event_categories: Optional list of event categories to filter by
+            timeout: Optional timeout in seconds (None = no timeout)
+            
+        Yields:
+            Event dictionaries
+        """
+        queue = self.get_queue(context_id)
+        if not queue:
+            logger.warning(f"No queue found for context {context_id}")
+            return
+        
+        start_time = asyncio.get_event_loop().time() if timeout else None
+        
+        while True:
+            # Check timeout
+            if timeout and start_time:
+                elapsed = asyncio.get_event_loop().time() - start_time
+                if elapsed > timeout:
+                    logger.debug(f"Stream timeout for context {context_id}")
+                    break
+            
+            try:
+                # Wait for event with timeout
+                wait_timeout = 1.0  # Check timeout every second
+                if timeout and start_time:
+                    remaining = timeout - (asyncio.get_event_loop().time() - start_time)
+                    if remaining <= 0:
+                        break
+                    wait_timeout = min(wait_timeout, remaining)
+                
+                event = await asyncio.wait_for(queue.get(), timeout=wait_timeout)
+                
+                # Filter by category if specified
+                if event_categories and event.get("category") not in event_categories:
+                    continue
+                
+                yield event
+                
+            except asyncio.TimeoutError:
+                # Check if we should continue or timeout
+                if timeout and start_time:
+                    elapsed = asyncio.get_event_loop().time() - start_time
+                    if elapsed >= timeout:
+                        break
+                continue
+            except Exception as e:
+                logger.error(f"Error in stream_events for context {context_id}: {e}")
+                break
+    
+    async def cleanup(self, context_id: str, delay: float = 60.0):
         """
         Schedule cleanup of event queue after delay.
         This allows time for any remaining events to be consumed.
         
         Args:
-            workflow_id: Workflow ID
+            context_id: Context ID
             delay: Delay in seconds before cleanup (default: 60 seconds)
         """
-        if workflow_id in self._cleanup_tasks:
+        if context_id in self._cleanup_tasks:
             # Cancel existing cleanup task
-            self._cleanup_tasks[workflow_id].cancel()
+            self._cleanup_tasks[context_id].cancel()
         
         async def _cleanup():
             try:
                 await asyncio.sleep(delay)
-                if workflow_id in self._queues:
+                if context_id in self._queues:
                     # Drain remaining events
-                    queue = self._queues[workflow_id]
+                    queue = self._queues[context_id]
                     while not queue.empty():
                         try:
                             queue.get_nowait()
                         except asyncio.QueueEmpty:
                             break
                     
-                    del self._queues[workflow_id]
-                    del self._locks[workflow_id]
-                    logger.info(f"Cleaned up event queue for workflow {workflow_id}")
+                    del self._queues[context_id]
+                    if context_id in self._locks:
+                        del self._locks[context_id]
+                    if context_id in self._subscribers:
+                        del self._subscribers[context_id]
+                    logger.info(f"Cleaned up event queue for context {context_id}")
             except asyncio.CancelledError:
                 pass
             except Exception as e:
-                logger.error(f"Error during cleanup for workflow {workflow_id}: {e}")
+                logger.error(f"Error during cleanup for context {context_id}: {e}")
             finally:
-                if workflow_id in self._cleanup_tasks:
-                    del self._cleanup_tasks[workflow_id]
+                if context_id in self._cleanup_tasks:
+                    del self._cleanup_tasks[context_id]
         
-        self._cleanup_tasks[workflow_id] = asyncio.create_task(_cleanup())
+        self._cleanup_tasks[context_id] = asyncio.create_task(_cleanup())
     
-    def has_queue(self, workflow_id: str) -> bool:
+    def has_queue(self, context_id: str) -> bool:
         """
-        Check if a queue exists for a workflow.
+        Check if a queue exists for a context.
         
         Args:
-            workflow_id: Workflow ID
+            context_id: Context ID
             
         Returns:
             True if queue exists, False otherwise
         """
-        return workflow_id in self._queues
+        return context_id in self._queues
 
 
+# Backward compatibility: ChatbotEventManager is an alias
+ChatbotEventManager = StreamingEventManager
+
 # Global singleton instance
-_event_manager = ChatbotEventManager()
+_event_manager = StreamingEventManager()
 
 
-def get_event_manager() -> ChatbotEventManager:
+def get_event_manager() -> StreamingEventManager:
     """Get the global event manager instance."""
     return _event_manager
 
diff --git a/modules/features/chatbot/mainChatbot.py b/modules/features/chatbot/mainChatbot.py
index 6f0cf770..ee74313d 100644
--- a/modules/features/chatbot/mainChatbot.py
+++ b/modules/features/chatbot/mainChatbot.py
@@ -158,15 +158,14 @@ async def chatProcess(
         # Emit message event for streaming (exact chatData format)
         message_timestamp = parseTimestamp(userMessage.publishedAt, default=getUtcTimestamp())
         await event_manager.emit_event(
-            workflow.id,
-            "chatdata",
-            "New message",
-            "message",
-            {
+            context_id=workflow.id,
+            event_type="chatdata",
+            data={
                 "type": "message",
                 "createdAt": message_timestamp,
                 "item": userMessage.dict()
-            }
+            },
+            event_category="chat"
         )
         
         # Update workflow status
@@ -538,7 +537,14 @@ async def _processChatbotMessage(
         workflow = interfaceDbChat.getWorkflow(workflowId)
         if not workflow:
             logger.error(f"Workflow {workflowId} not found during processing")
-            await event_manager.emit_event(workflowId, "error", f"Workflow {workflowId} nicht gefunden", "error")
+            await event_manager.emit_event(
+                context_id=workflowId,
+                event_type="error",
+                data={"error": f"Workflow {workflowId} nicht gefunden"},
+                event_category="workflow",
+                message=f"Workflow {workflowId} nicht gefunden",
+                step="error"
+            )
             return
         
         # Check if workflow was stopped before starting
@@ -896,15 +902,14 @@ Beginne DIREKT mit "Aus der Datenbank habe ich..." (wenn Daten vorhanden) oder "
         # Emit message event for streaming (exact chatData format)
         message_timestamp = parseTimestamp(assistantMessage.publishedAt, default=getUtcTimestamp())
         await event_manager.emit_event(
-            workflowId,
-            "chatdata",
-            "New message",
-            "message",
-            {
+            context_id=workflowId,
+            event_type="chatdata",
+            data={
                 "type": "message",
                 "createdAt": message_timestamp,
                 "item": assistantMessage.dict()
-            }
+            },
+            event_category="chat"
         )
         
         # Update workflow status to completed (only if not stopped)
@@ -921,11 +926,12 @@ Beginne DIREKT mit "Aus der Datenbank habe ich..." (wenn Daten vorhanden) oder "
         # Emit completion event only if workflow wasn't stopped
         if not await _check_workflow_stopped(interfaceDbChat, workflowId):
             await event_manager.emit_event(
-                workflowId,
-                "complete",
-                "Chatbot-Verarbeitung abgeschlossen",
-                "complete",
-                {"workflowId": workflowId}
+                context_id=workflowId,
+                event_type="complete",
+                data={"workflowId": workflowId},
+                event_category="workflow",
+                message="Chatbot-Verarbeitung abgeschlossen",
+                step="complete"
             )
         
         # Schedule cleanup
@@ -968,15 +974,14 @@ Beginne DIREKT mit "Aus der Datenbank habe ich..." (wenn Daten vorhanden) oder "
             # Emit message event for streaming (exact chatData format)
             message_timestamp = parseTimestamp(errorMessage.publishedAt, default=getUtcTimestamp())
             await event_manager.emit_event(
-                workflowId,
-                "chatdata",
-                "New message",
-                "message",
-                {
+                context_id=workflowId,
+                event_type="chatdata",
+                data={
                     "type": "message",
                     "createdAt": message_timestamp,
                     "item": errorMessage.dict()
-                }
+                },
+                event_category="chat"
             )
             
             # Update workflow status to error (only if not stopped)
diff --git a/modules/interfaces/interfaceDbChatObjects.py b/modules/interfaces/interfaceDbChatObjects.py
index 40e30eaa..ac8bb586 100644
--- a/modules/interfaces/interfaceDbChatObjects.py
+++ b/modules/interfaces/interfaceDbChatObjects.py
@@ -1058,6 +1058,26 @@ class ChatObjects:
                 actionName=createdMessage.get("actionName")
             )
             
+            # Emit message event for streaming (if event manager is available)
+            try:
+                from modules.features.chatbot.eventManager import get_event_manager
+                event_manager = get_event_manager()
+                message_timestamp = parseTimestamp(chat_message.publishedAt, default=getUtcTimestamp())
+                # Emit message event in exact chatData format: {type, createdAt, item}
+                asyncio.create_task(event_manager.emit_event(
+                    context_id=workflowId,
+                    event_type="chatdata",
+                    data={
+                        "type": "message",
+                        "createdAt": message_timestamp,
+                        "item": chat_message.dict()
+                    },
+                    event_category="chat"
+                ))
+            except Exception as e:
+                # Event manager not available or error - continue without emitting
+                logger.debug(f"Could not emit message event: {e}")
+            
             # Debug: Store message and documents for debugging - only if debug enabled
             storeDebugMessageAndDocuments(chat_message, self.currentUser)
             
@@ -1419,15 +1439,14 @@ class ChatObjects:
             log_timestamp = parseTimestamp(createdLog.get("timestamp"), default=getUtcTimestamp())
             # Emit log event in exact chatData format: {type, createdAt, item}
             asyncio.create_task(event_manager.emit_event(
-                workflowId,
-                "chatdata",
-                "New log",
-                "log",
-                {
+                context_id=workflowId,
+                event_type="chatdata",
+                data={
                     "type": "log",
                     "createdAt": log_timestamp,
                     "item": ChatLog(**createdLog).dict()
-                }
+                },
+                event_category="chat"
             ))
         except Exception as e:
             # Event manager not available or error - continue without emitting
